package com.landray.kmss.sys.attachment.plugin.wpsAddons.util;

import java.util.List;
import java.util.Date;
import com.landray.kmss.sys.attachment.service.ISysAttMainCoreInnerService;
import java.util.Collection;
import org.apache.commons.collections.CollectionUtils;
import java.util.Calendar;
import com.landray.kmss.util.DbUtils;
import com.landray.kmss.util.UserUtil;
import com.landray.kmss.util.SpringBeanUtil;
import com.landray.kmss.sys.attachment.service.ISysAttachmentWpsService;
import com.landray.kmss.util.StringUtil;
import com.alibaba.fastjson.JSONObject;
import com.landray.kmss.framework.plugin.core.config.IExtension;
import com.landray.kmss.sys.attachment.plugin.wpsAddons.service.ISysAttachmentWpsAddonsExt;
import com.landray.kmss.framework.service.plugin.Plugin;
import java.util.Map;
import org.slf4j.LoggerFactory;
import org.slf4j.Logger;

public class SysAttachmentWpsAddonsLockUtils
{
    private static final Logger logger;
    
    static {
        logger = LoggerFactory.getLogger(SysAttachmentWpsAddonsLockUtils.class);
    }
    
    public static boolean handle(final Map<String, String> params) throws Exception {
        final IExtension[] extensions = Plugin.getExtensions("com.landray.kmss.sys.attachment.wpsAddons.ext", "*", "lock");
        final IExtension extension = Plugin.getExtension(extensions, "key", (String)params.get("type"));
        if (extension == null) {
            throw new RuntimeException("加载项扩展点类型[" + params.get("type") + "]不存在");
        }
        final ISysAttachmentWpsAddonsExt ext = (ISysAttachmentWpsAddonsExt)Plugin.getParamValue(extension, "provider");
        return ext.execute((Map)params);
    }
    
    public static boolean hearts(final JSONObject params) throws Exception {
        if (params == null) {
            return false;
        }
        if (StringUtil.isNull(params.getString("fdId"))) {
            return false;
        }
        final String sql = "update sys_attachment_wps set fd_heart_time=:fd_heart_time where fd_attmain_id=:fd_id and fd_user_id=:fd_user_id";
        final ISysAttachmentWpsService sysAttachmentWpsService = (ISysAttachmentWpsService)SpringBeanUtil.getBean("sysAttachmentWpsService");
        final int i = sysAttachmentWpsService.getBaseDao().getHibernateSession().createNativeQuery(sql).setParameter("fd_user_id", (Object)UserUtil.getKMSSUser().getPerson().getFdId()).setParameter("fd_heart_time", (Object)DbUtils.getDbTime()).setParameter("fd_id", (Object)params.getString("fdId")).executeUpdate();
        return i > 0;
    }
    
    public static void forceUnlock() throws Exception {
        final Date time = DbUtils.getDbTime();
        final Calendar calendar = Calendar.getInstance();
        calendar.setTime(time);
        calendar.add(12, -3);
        Date endTime = calendar.getTime();
        String sql = "select fd_attmain_id from sys_attachment_wps where fd_heart_time < :endTime and fd_attmain_id is not null and fd_user_id is not null";
        final ISysAttachmentWpsService sysAttachmentWpsService = (ISysAttachmentWpsService)SpringBeanUtil.getBean("sysAttachmentWpsService");
        List list = sysAttachmentWpsService.getBaseDao().getHibernateSession().createNativeQuery(sql).setParameter("endTime", (Object)endTime).list();
        if (CollectionUtils.isNotEmpty((Collection)list)) {
            final ISysAttMainCoreInnerService sysAttMainService = (ISysAttMainCoreInnerService)SpringBeanUtil.getBean("sysAttMainService");
            sql = "update sys_att_main set fd_last_open_time=null,fd_person_id=null where fd_id in (:ids) and fd_person_id is not null";
            sysAttMainService.getBaseDao().getHibernateSession().createNativeQuery(sql).setParameterList("ids", (Collection)list).executeUpdate();
            sql = "delete from sys_attachment_wps where fd_attmain_id in (:ids)";
            sysAttachmentWpsService.getBaseDao().getHibernateSession().createNativeQuery(sql).setParameterList("ids", (Collection)list).executeUpdate();
        }
        calendar.setTime(time);
        calendar.add(11, -4);
        endTime = calendar.getTime();
        sql = "select fd_attmain_id from sys_attachment_wps where doc_alter_time < :endTime and fd_attmain_id is not null and fd_user_id is not null";
        list = sysAttachmentWpsService.getBaseDao().getHibernateSession().createNativeQuery(sql).setParameter("endTime", (Object)endTime).list();
        if (CollectionUtils.isNotEmpty((Collection)list)) {
            final ISysAttMainCoreInnerService sysAttMainService = (ISysAttMainCoreInnerService)SpringBeanUtil.getBean("sysAttMainService");
            sql = "update sys_att_main set fd_last_open_time=null,fd_person_id=null where fd_id in (:ids) and fd_person_id is not null";
            sysAttMainService.getBaseDao().getHibernateSession().createNativeQuery(sql).setParameterList("ids", (Collection)list).executeUpdate();
            sql = "delete from sys_attachment_wps where fd_attmain_id in (:ids)";
            sysAttachmentWpsService.getBaseDao().getHibernateSession().createNativeQuery(sql).setParameterList("ids", (Collection)list).executeUpdate();
        }
    }
}
